<?php
/*
Widget Name: SiteOrigin Preset Field
Author: SiteOrigin
Author URI: https://siteorigin.com
Widget URI: https://siteorigin.com/docs/widgets-bundle/form-building/presets.md
*/

class SOWB_Preset_Field_Demo extends SiteOrigin_Widget {
	function __construct() {
		parent::__construct(
			'sow-preset-field-demo',
			__( 'SiteOrigin Preset Field', 'siteorigin-docs' ),
			array(),
			array(),
			false,
			plugin_dir_path( __FILE__ )
		);
	}

	function get_widget_form() {
		// Load presets from file.
		$presets = json_decode( file_get_contents( plugin_dir_path( __FILE__ ) . 'data/presets.json' ), true );

		// Preset array
		// $presets = array(
		// 	'test' => array( // Preset 1
		// 		'label' => 'Test 1',
		// 		'values' => array(
		// 			'text' => 'Test 1 example text',
		// 		),
		// 	),
		// 	'test-2' => array( // Preset 2
		// 		'label' => 'Test 2',
		// 		'values' => array(
		// 			'text' => 'Test 1 example text',
		//     				'color' => '#0f0',
		// 		),
		// 	),
		// );

		return $this->dynamic_preset_state_handler(
		    'selected_theme', // state_name
		    $presets, // preset_data
		    array( // fields
				'preset' => array(
					'type' => 'presets',
					'label' => __( 'Theme', 'siteorigin-docs'),
					'default_preset' => 'test-2',
					'options' => $presets,
					'state_emitter' => array(
						'callback' => 'select',
						'args' => array( 'selected_theme' ),
					),
				),
				'test' => array(
					'type' => 'text',
					'label' => __( 'Text', 'siteorigin-docs' ),
				),
				'color' => array(
					'type' => 'color',
					'label' => __( 'color', 'siteorigin-docs' ),
				),

			)
		);
	}
}
siteorigin_widget_register( 'sow-preset-field-demo', __FILE__, 'SOWB_Preset_Field_Demo' );
